; +---------------+-----------+
; | CHEMICAL A-21 | Ryan Touk |
; +---------------+-----------+
; |  8.20.2011 . Creation (Ludum Dare 21)
; |   .21.     - Version 1.00 (submitted for LD48 #21)
; |   .23.     . Tab key toggles less/more detail
; |   .24.     - Version 1.01, cursor now shown (Windows only)
; |   .30.     - Version 1.02, fix ClearScreen in windowed mode (PB 4.60b4)


; NOTE: This code was written in just a few hours, and is
;       absolutely hideous -- variables declared all over
;       the place, few comments, inefficent, arbitrary
;       names for variables and constants, and a lot of
;       hard-coded gameplay flow...
;       
;       But sometimes that's what Ludum Dare is all about.





;- Constants

#L_Title   = "CHEMICAL A-21"
#L_Author  = "Ryan Touk"
#L_Version = "1.02"

#L_SW = 640
#L_SH = 480

#L_Infected = %00000001
#L_Wall     = %00000010
#L_Desk     = %00000100
#L_Nitro    = %00001000
#L_Tetra    = %00010000

CompilerIf (#PB_Compiler_OS = #PB_OS_Windows)
  #L_IconError = #MB_ICONERROR
CompilerElse
  #L_IconError = #Null
CompilerEndIf

;MessageRequester("GetCurrentDirectory", GetCurrentDirectory())













;- Structures

Structure GRID
  Infection.i
  Flags.i
  Glow.i
  CheckID.i
EndStructure














;- Variables

EnableExplicit

Global InWindow.i = 1, ShakeCount.i = 0, DrawLess.i = #False

Global FFont.i = LoadFont(0, "Tahoma", 14)
If (Not FFont)
  FFont = LoadFont(0, "Arial", 14)
EndIf
If (Not FFont)
  FFont = LoadFont(0, "Helvetica", 14)
EndIf

Global Dim ICol.i(255)
Define i.i
For i = 0 To 100 : ICol(i) = RGB(0,i*2.549,0) : Next i
For i = 0 To 55 : ICol(i+100) = RGB(i*4.63,255,i*4.63) : Next i
For i = 0 To 100 : ICol(i+155) = RGB(255-i*2.49,255-i*1.5,255-i*2.49) : Next i
ICol(1) = RGB(64,192,0)

Global Dim G.GRID(0,0)

Global LW.i, LH.i
Global xoff.i, yoff.i
Global BW.i, BH.i

Global WallsLeft.i = 0
Global GrowRate.i  = 0
Global Threshold.i = 0
Global Level.i     = 1
Global Total.i     = 0
Global StartWith.i = 0
Global CheckID.i   = 1
Global AllSafe.i   = 0
Global MyScore.i   = 0
Global RetryNow.i  = 0

Enumeration
  #Play
  #Transition
  #Texter
EndEnumeration

Global Mode.i = #Texter
Global ModeCount.i

Global TText.s, TCol.i
















;- Macros

CompilerIf (#PB_Compiler_OS = #PB_OS_Windows)
  Macro ShowMouse()
    ShowCursor_(#True)
  EndMacro
CompilerElse
  Macro ShowMouse()
  EndMacro
CompilerEndIf

;- Procedures

Procedure Shutdown()
  End
EndProcedure

Procedure Error(Message.s)
  MessageRequester(#L_Title + " - Error", Message, #L_IconError)
  Shutdown()
EndProcedure

Procedure LoadLevel(Num.i)
  Level = Num
  Total.i = #L_SH
  If (#L_SW < #L_SH) : Total = #L_SW : EndIf
  
  Select (Level)
    Case 2 : Restore Level2
    Case 3 : Restore Level3
    Case 4 : Restore Level4
    Case 5 : Restore Level5
    Case 6 : Restore Level6
    Case 7 : Restore Level7
    Case 8 : Restore Level8
    Case 9 : Restore Level9
    Case 10: Restore Level10
    Default
      Restore Level1
  EndSelect
  
  Read.i LW
  Read.i LH
  
  BW = Total / LW
  BH = Total / LH
  
  xoff = (#L_SW - Total)/2
  yoff = (#L_SH - Total)/2
  
  Read.i WallsLeft
  Read.i GrowRate
  Read.i Threshold
  
  Global Dim G.GRID(LW - 1, LH - 1)
  
  Define j.i
  For j = 0 To LH - 1
    Define St.s
    Read.s St.s
    St = UCase(St)
    Define i.i
    For i = 0 To LW - 1
      Select PeekC(@St + i*SizeOf(CHARACTER))
        Case 'I' : G(i,j)\Flags | #L_Infected
        Case 'W' : G(i,j)\Flags | #L_Wall
        Case 'D' : G(i,j)\Flags | #L_Wall | #L_Desk
        Case 'N' : G(i,j)\Flags | #L_Nitro
        Case 'T' : G(i,j)\Flags | #L_Tetra
      EndSelect
    Next i
  Next j
  
  StartWith = WallsLeft
;   For i = 0 To LW - 1
;     For j = 0 To LH - 1
;       If (G(i,j)\Flags & #L_Wall)
;         StartWith + 1
;       EndIf
;     Next j
;   Next i
  
  If (StartWith = 0) : StartWith = 1 : EndIf
  
  AllSafe = 0
  Mode = #Play
  RetryNow = 0
  ShakeCount = 0
  
EndProcedure

Global SoundInit.i

Procedure Recheck()
  Static Added.i, Add.i, i.i, j.i, k.i
  Static OldSafe.i
  OldSafe = AllSafe
  Added = 1
  AllSafe = 1
  While (Added)
    Added = #False
    For i = 0 To LW - 1
      For j = 0 To LH - 1
        If (G(i,j)\CheckID <> CheckID)
          If (G(i,j)\Flags & #L_Infected)
            G(i,j)\CheckID = CheckID
            Added = #True
          ElseIf (Not (G(i,j)\Flags & #L_Wall))
            k = 0
            If (i > 0) And (G(i-1,j)\CheckID = CheckID) : k = 1
            ElseIf (j > 0) And (G(i,j-1)\CheckID = CheckID) : k = 1
            ElseIf (i < LW-1) And (G(i+1,j)\CheckID = CheckID) : k = 1
            ElseIf (j < LH-1) And (G(i,j+1)\CheckID = CheckID) : k = 1
            EndIf
            If (k)
              G(i,j)\CheckID = CheckID
              Added = #True
            EndIf
          EndIf
        Else
          If (i = 0) Or (j = 0) Or (i = LW-1) Or (j = LH-1)
            AllSafe = 0
          EndIf
        EndIf
      Next j
    Next i
  Wend
  CheckID + 1
  If (AllSafe And (Not OldSafe) And SoundInit)
    PlaySound(3)
  EndIf
EndProcedure

Procedure SwapScreen()
  If (InWindow)
    ReleaseMouse(1)
    CloseScreen()
    CloseWindow(0)
    InWindow = 0
    If (Not OpenScreen(#L_SW, #L_SH, 32, #L_Title))
      Error("A " + Str(#L_SW) + "x" + Str(#L_SH) + "x32 screen could not be opened!")
    EndIf
    ReleaseMouse(0)
  Else
    ReleaseMouse(1)
    CloseScreen()
    If (Not OpenWindow(0, 0, 0, #L_SW, #L_SH, #L_Title + " : Ctrl+F for fullscreen", #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget|#PB_Window_NoGadgets))
      Error("Window could not be opened!")
    ElseIf (Not OpenWindowedScreen(WindowID(0), 0, 0, #L_SW, #L_SH, 0, 0, 0))
      Error("Screen could not be opened!")
    EndIf
    InWindow = 1
    ReleaseMouse(0)
    ShowMouse()
  EndIf
EndProcedure
























;- Initialize

If (Not InitSprite())
  Error("Screen could not be initialized!")
ElseIf (Not InitMouse())
  Error("Mouse input could not be initialized!")
ElseIf (Not InitKeyboard())
  Error("Keyboard input could not be initialized!")
ElseIf (Not OpenWindow(0, 0, 0, #L_SW, #L_SH, #L_Title + " : Ctrl+F for fullscreen", #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget|#PB_Window_NoGadgets))
  Error("Window could not be opened!")
ElseIf (Not OpenWindowedScreen(WindowID(0), 0, 0, #L_SW, #L_SH, 0, 0, 0))
  Error("Screen could not be opened!")
EndIf

Global SoundInit.i = InitSound()
UseOGGSoundDecoder()
If (SoundInit)
  CompilerIf (#PB_Compiler_OS = #PB_OS_Windows)
    LoadSound(0, "warn.wav") : SoundVolume(0, 75)
    LoadSound(1, "clean.wav")
    LoadSound(2, "click.wav")
    LoadSound(3, "win.wav")
    LoadSound(4, "lose.wav")
    LoadSound(5, "bump.wav")
    LoadSound(6, "take.wav") : SoundVolume(6, 75)
    LoadSound(7, "nitr.wav")
    LoadSound(9, "cant.wav")
  CompilerElse
    LoadSound(0, "stereo/warn.wav") : SoundVolume(0, 75)
    LoadSound(1, "stereo/clean.wav")
    LoadSound(2, "stereo/click.wav")
    LoadSound(3, "stereo/win.wav")
    LoadSound(4, "stereo/lose.wav")
    LoadSound(5, "stereo/bump.wav")
    LoadSound(6, "stereo/take.wav") : SoundVolume(6, 75)
    LoadSound(7, "stereo/nitr.wav")
    LoadSound(9, "stereo/cant.wav")
  CompilerEndIf
  LoadSound(8, "a21.ogg", #PB_Sound_Streaming)
EndIf

SetFrameRate(50)
ClearScreen(0)
FlipBuffers()



















;- Begin

LoadLevel(1)
Mode = #Texter
Restore IntroText;IntroText
Read.s TText
Read.i TCol

Global mx.i, my.i, sx.i, sy.i, Active.i
Define i.i, j.i, k.i, St.s
Define x0.i, y0.i, x1.i, y1.i, Col
Define omc.i





















;- Main Loop

Global Time.i

Repeat
  Time = ElapsedMilliseconds()
  
  If (InWindow)
  Define Event.i, ExitFlag.i
  Event = WindowEvent()
  While (Event)
    If (Event = #PB_Event_CloseWindow)
      ExitFlag = #True
    EndIf
    Event = WindowEvent()
  Wend
  EndIf
  
  ; Update mouse selection
  If (IsScreenActive())
    If (InWindow)
      ReleaseMouse(0)
    EndIf
    ExamineMouse()
    ExamineKeyboard()
    If (Mode <> #Texter)
    mx.i = MouseX()
    my.i = MouseY()
    sx.i = LW * (mx-xoff) / Total
    sy.i = LH * (my-yoff) / Total
    
    Active.i = 1
    If (mx < xoff) : sx = 0 : Active = 0 : EndIf
    If (my < yoff) : sy = 0 : Active = 0 : EndIf
    If (sx >= LW) : sx = LW-1 : Active = 0 : EndIf
    If (sy >= LH) : sy = LH-1 : Active = 0 : EndIf
    
    If (DrawLess)
      G(sx,sy)\Glow + 255
    Else
      G(sx,sy)\Glow + 100
    EndIf
    If (G(sx,sy)\Glow > 255)
      G(sx,sy)\Glow = 255
    EndIf
    EndIf
  Else
    If (InWindow)
      ReleaseMouse(1)
    EndIf
    Active.i = 0
  EndIf
  
  If (KeyboardReleased(#PB_Key_F) And (KeyboardPushed(#PB_Key_LeftControl) Or KeyboardPushed(#PB_Key_RightControl)))
    SwapScreen()
    Delay(250)
  EndIf
  
  If (KeyboardReleased(#PB_Key_Tab)) And (Mode = #Play)
    DrawLess = 1 - DrawLess
    If (SoundInit) : PlaySound(6) : EndIf
  EndIf
  
  ClearScreen(0)
  If (StartDrawing(ScreenOutput()))
    
    ; Update infections
    If (Mode = #Play)
      For i.i = 0 To LW - 1
        For j.i = 0 To LH - 1
          If (G(i,j)\Flags & #L_Infected)
            G(i,j)\Infection + GrowRate
            If (G(i,j)\Infection > $FFFF)
              G(i,j)\Infection = $FFFF
            EndIf
          ElseIf (Not (G(i,j)\Flags & #L_Wall))
            k = #False
            If (i > 0) And (G(i-1,j)\Infection > Threshold) : k = 1
            ElseIf (j > 0) And (G(i,j-1)\Infection > Threshold) : k = 1
            ElseIf (i < LW - 1) And (G(i+1,j)\Infection > Threshold) : k = 1
            ElseIf (j < LH - 1) And (G(i,j+1)\Infection > Threshold) : k = 1
            EndIf
            If (k)
              G(i,j)\Flags | #L_Infected
              If (G(i,j)\Flags & #L_Nitro)
                GrowRate * 2
                G(i,j)\Flags & (~#L_Nitro)
                If (SoundInit) : PlaySound(7) : EndIf
              EndIf
              If (G(i,j)\Flags & #L_Tetra)
                Threshold * 2
                G(i,j)\Flags & (~#L_Tetra)
                If (SoundInit) : PlaySound(6) : EndIf
              EndIf
              If (i = 0) Or (j = 0) Or (i = LW - 1) Or (j = LH - 1)
                If (Not RetryNow) And (SoundInit)
                  PlaySound(4)
                  ShakeCount = 10
                EndIf
                RetryNow = 1
              EndIf
            EndIf
            
          EndIf
          If (Not Active) Or (sx <> i) Or (sy <> j)
            If (DrawLess)
              G(i,j)\Glow - 255
            Else
              G(i,j)\Glow - 15
            EndIf
            If (G(i,j)\Glow < 0)
              G(i,j)\Glow = 0
            EndIf
          EndIf
        Next j
      Next i
      
      ; Draw and erase walls
      If (Active)
        If (MouseButton(1))
          If (WallsLeft > 0)
          If (Not (G(sx,sy)\Flags & #L_Wall)) And (Not (G(sx,sy)\Flags & #L_Infected)) And (Not (G(sx,sy)\Flags & #L_Nitro)) And (Not (G(sx,sy)\Flags & #L_Tetra))
            G(sx,sy)\Flags | #L_Wall
            G(sx,sy)\Flags & (~#L_Infected)
            G(sx,sy)\Infection = 0
            WallsLeft - 1
            If (WallsLeft = 0) And (SoundInit)
              PlaySound(9)
            EndIf
            Recheck()
            If (SoundInit) : PlaySound(5) : EndIf
          EndIf
          Else
            If (omc = 0) And (SoundInit) : PlaySound(9) : EndIf
          EndIf
          omc = 1
        Else
          omc = 0
        EndIf
        If (MouseButton(2))
          If ((G(sx,sy)\Flags & #L_Wall)) And (Not (G(sx,sy)\Flags & #L_Nitro)) And (Not (G(sx,sy)\Flags & #L_Tetra))
            G(sx,sy)\Flags & (~(#L_Wall|#L_Desk))
            WallsLeft + 1
            Recheck()
            If (SoundInit) : PlaySound(6) : EndIf
          EndIf
        EndIf
      EndIf
    EndIf
    
    ; Draw wall meters on sides
    If (WallsLeft > 0) And (Mode <> #Texter)
      y0 = #L_SH * WallsLeft / StartWith
      Box(0, #L_SH - y0, xoff, y0, $202020)
      Box(#L_SW-xoff, #L_SH - y0, xoff, y0, $202020)
    EndIf
    
    ; Display score and walls left
    If (Mode <> #Texter)
      DrawingFont(FFont)
      DrawingMode(#PB_2DDrawing_Transparent)
      DrawText(10, 10, Str(MyScore), $FFFF00)
      St.s = Str(WallsLeft)
      If (WallsLeft > 0)
        Col = $C0C0C0
      Else
        If (MouseButton(1)) And (Mode = #Play)
          DrawingMode(#PB_2DDrawing_Default)
        EndIf
        Col = $0000FF
      EndIf
      DrawText(10, #L_SH - 10 - TextHeight(St), St, Col, $000080)
    EndIf
    
    ; Draw playing field
    If (Mode <> #Texter)
    
    Define rx.i,ry.i
    If (ShakeCount)
      ShakeCount - 1
      rx = Random(ShakeCount<<2) - ShakeCount<<1
      ;ry = Random(ShakeCount<<2) - ShakeCount<<1
      ry = 0
    Else
      rx = 0
      ry = 0
    EndIf
    
    x1.i = xoff + rx
    y1.i = yoff + ry
    

    
    For i.i = 1 To LW
      x0.i = x1.i
      x1.i = xoff + rx + Total * i / LW
      For j.i = 1 To LH
        y0.i = y1.i
        y1.i = yoff + ry + Total * j / LH
        
        If (G(i-1,j-1)\Flags & #L_Infected)
          If (Mode = #Play)
            Box(x0, y0, x1 - x0, y1 - y0, ICol(G(i-1,j-1)\Infection >> 8))
          Else
            Box(x0, y0, x1 - x0, y1 - y0, (Random(1)*255)<<8)
          EndIf
          If (Mode = #Play) And (Not DrawLess) And (Random(3) = 0)
          For k.i = 0 To 3
            Box(x0 + Random(BW-1), y0 + Random(BH-1), 2, 2, ICol(Random(G(i-1,j-1)\Infection >> 8)))
          Next k
          EndIf
        ElseIf (G(i-1,j-1)\Flags & #L_Nitro) And (Mode = #Play)
          Col.i = Sin(Time*0.001)*$20 + $C0
          Circle(x0 + bw/2, y0 + bh/2, bh/3, RGB(0,Col*2/3,Col))
        ElseIf (G(i-1,j-1)\Flags & #L_Tetra) And (Mode = #Play)
          Col.i = Sin(Time*0.001)*$20 + $C0
          Circle(x0 + bw/2, y0 + bh/2, bh/3, RGB(Col,Col,0))
        ElseIf (G(i-1,j-1)\Flags & #L_Wall)
          If (Mode = #Play)
            Col.i = Sin(Time*0.001)*$20 + $60
            Col   = RGB(Col,Col,Col)
            If (G(i-1,j-1)\Flags & #L_Desk)
              Col = Col & $007FFF
              Box(x0 + 3, y0 + 3, x1 - x0 - 6, y1 - y0 - 6, Col)
            Else
              Box(x0, y0, x1 - x0, y1 - y0, Col)
              If (Not DrawLess)
                Col   = $A0A0A0 - Col
                Box(x0 + 2, y0 + 2, x1 - x0 - 4, y1 - y0 - 4, Col)
              EndIf
            EndIf
          Else
            Col = Random(1)*128
            Box(x0, y0, x1 - x0, y1 - y0, RGB(Col,Col,Col))
          EndIf
        EndIf
        
        If (G(i-1,j-1)\Glow > 0) And (Mode = #Play)
          DrawingMode(#PB_2DDrawing_Outlined)
          Box(x0, y0, x1-x0, y1-y0, G(i-1,j-1)\Glow)
          DrawingMode(#PB_2DDrawing_Default)
        EndIf
        
      Next j
      y1.i = yoff + ry
    Next i
    EndIf
    
    ; Draw outline box
    If (Mode <> #Texter)
      DrawingMode(#PB_2DDrawing_Outlined)
      If (RetryNow)
        Col = $0000FF
      Else
        Col = $404040
      EndIf
      Box(xoff - 1, yoff - 1, Total + 2, Total + 2, Col)
    EndIf
    
    ; Display text popups
    If (AllSafe) And (Mode = #Play)
      DrawingMode(#PB_2DDrawing_Default)
      St = "PRESS ENTER TO CONTINUE."
      DrawText((#L_SW - TextWidth(St))/2, #L_SH - 50 - TextHeight(St), St, $00FF00)
    EndIf
    If (RetryNow)
      DrawingMode(#PB_2DDrawing_Default)
      St = "PRESS R TO RESTART."
      DrawText((#L_SW - TextWidth(St))/2, #L_SH - 50 - TextHeight(St), St, $0000FF)
    EndIf
    
    ; Handle scripts, music, sounds
    If (Mode = #Texter)
      If (Left(TText, 1) = "&")
        If (SoundInit)
          StopSound(8)
        EndIf
        Read.s TText
        Read.i TCol
      EndIf
      If (Left(TText, 1) = "~")
        ExitFlag = #True
      EndIf
      If (Left(TText, 1) = "#")
        If (SoundInit)
          PlaySound(0)
        EndIf
        TText = Mid(TText, 2)
      EndIf
      If (Left(TText, 1) = "$")
        If (SoundInit)
          PlaySound(2)
        EndIf
        TText = Mid(TText, 2)
      EndIf
      If (Left(TText, 1) = "%")
        If (SoundInit)
          PlaySound(9)
        EndIf
        TText = Mid(TText, 2)
      EndIf
      TText = ReplaceString(TText, "%S", Str(MyScore))
      DrawingFont(FFont)
      DrawingMode(#PB_2DDrawing_Transparent)
      DrawText((#L_SW - TextWidth(TText))/2, (#L_SH/2) - TextHeight(TText), TText, TCol)
      If (KeyboardReleased(#PB_Key_Space)) Or (KeyboardReleased(#PB_Key_Return))
        Read.s TText
        If (TText = "*")
          PlaySound(8, #PB_Sound_Loop)
          TText = ""
        EndIf
        If (TText)
          Read.i TCol
        Else
          MouseLocate(#L_SW/2,#L_SH/2)
          If (InWindow) : ShowMouse() : EndIf
          LoadLevel(Level)
        EndIf
      EndIf
    EndIf
    
    StopDrawing()
  EndIf
  
  FlipBuffers()
  
  ; Escape or restart level
  If KeyboardPushed(#PB_Key_Escape)
    ExitFlag = #True
  ElseIf KeyboardReleased(#PB_Key_R) And (Mode = #Play)
    If (SoundInit) : PlaySound(5) : EndIf
    LoadLevel(Level)
  EndIf
  
  ; Transition to next level or script
  If (Mode = #Transition)
    If (ModeCount > 0) : ModeCount - 1 : EndIf
    If (WallsLeft > 0) : WallsLeft - 1 : MyScore + 1 : EndIf
    If (ModeCount = 0) And (WallsLeft = 0)
      Select Level
        Case 1 : Level + 1 : Restore L2Text : Read.s TText : Read.i TCol.i : Mode = #Texter
        Case 2 : Level + 1 : Restore L3Text : Read.s TText : Read.i TCol.i : Mode = #Texter
        Case 3 : Level + 1 : Restore L4Text : Read.s TText : Read.i TCol.i : Mode = #Texter
        Case 4 : Level + 1 : Restore L5Text : Read.s TText : Read.i TCol.i : Mode = #Texter
        Case 5 : Level + 1 : Restore L6Text : Read.s TText : Read.i TCol.i : Mode = #Texter
        Case 6 : Level + 1 : Restore L7Text : Read.s TText : Read.i TCol.i : Mode = #Texter
        Case 9 : Level + 1 : Restore L10Text : Read.s TText : Read.i TCol.i : Mode = #Texter
        Case 10 : Level + 1 : Restore EndText : Read.s TText : Read.i TCol.i : Mode = #Texter
        Default : LoadLevel(Level + 1)
      EndSelect
    EndIf
  EndIf

  ; Enter to proceed
  If (KeyboardReleased(#PB_Key_Return)) And (AllSafe) And (Mode = #Play)
    If (SoundInit) : PlaySound(1) : EndIf
    Mode = #Transition
    ModeCount = WallsLeft
    If (ModeCount < 30)
      ModeCount = 30
    EndIf
  EndIf
  
  Delay(5)
  
Until (ExitFlag)
If (InWindow)
  HideWindow(0,1)
  Delay(500)
EndIf
Shutdown()


;- Data Section

DataSection
  IntroText:
  ;Data.s "CHEMICAL A-21" : Data.i $FFFFFF
  Data.s "#WARNING" : Data.i $0000FF
  Data.s "STRUCTURAL FAILURE DETECTED IN STORAGE SECTOR" : Data.i $FFFFFF
  Data.s "#WARNING" : Data.i $0000FF
  Data.s "ESCAPE OF CHEMICAL A-21 IMMINENT" : Data.i $FFFFFF
  Data.s "#WARNING" : Data.i $0000FF
  Data.s "EMERGENCY CONTAINMENT PROCEDURES INITIATED:" : Data.i $FFFFFF
  Data.s "$LEFT-CLICK TO PLACE BARRIERS" : Data.i $00FF00
  Data.s "$RIGHT-CLICK TO PICK UP BARRIERS" : Data.i $00FF00
  Data.s "LESS BARRIERS PLACED MEANS HIGHER SCORES" : Data.i $FFFFFF
  Data.s "I MEAN... HIGHER 'EFFICIENCY'..." : Data.i $FFFFFF
  Data.s "DO NOT ALLOW A-21 TO REACH THE EDGES!" : Data.i $00FF00
  Data.s "$BEGIN!" : Data.i $0000FF
  Data.s "*"

  Level1:
  Data.i 30,30, 50, $010,$400
  Data.s ".............................."
  Data.s ".............................."
  Data.s ".............................."
  Data.s "...WW........................."
  Data.s "...WW........................."
  Data.s ".............................."
  Data.s ".............................."
  Data.s ".......................W......"
  Data.s ".............................."
  Data.s ".............................."
  Data.s "..........WWWWWWWWW..........."
  Data.s "..........W.......W..........."
  Data.s "..................W..........."
  Data.s "..........W.......W..........."
  Data.s "..........W...I...W..........."
  Data.s ".....W....W.......W..........."
  Data.s "..........W..................."
  Data.s "..................W..........."
  Data.s "............WWWWWWW..........."
  Data.s ".............................."
  Data.s ".............................."
  Data.s "..........................W..."
  Data.s ".............................."
  Data.s ".............................."
  Data.s "....WW........................"
  Data.s "....WW..........WWW..........."
  Data.s "................WWW..........."
  Data.s "................WWW..........."
  Data.s ".............................."
  Data.s ".............................."

  L2Text:
  Data.s "$WELL DONE! THE DAY IS SAV-" : Data.i $FFFFFF
  Data.s "#WARNING" : Data.i $0000FF
  Data.s "CHEMICAL A-21 DETECTED IN OFFICE AREA" : Data.i $FFFFFF
  Data.s "BEGIN!" : Data.i $0000FF
  Data.s ""

  Level2:
  Data.i 30,30, 50, $010,$400
  Data.s "WWWWWWWWW.......WWWWWWWWWWWWWW"
  Data.s "W.......W.......W............W"
  Data.s "........W.......W..D.D.D.D.D.W"
  Data.s "W...............W............W"
  Data.s "W.......W.......W............W"
  Data.s "WDDD....W.......W............W"
  Data.s "WWWWWWWWW....................W"
  Data.s "W.......W....................W"
  Data.s "W.....I.W.......W............W"
  Data.s "W.......W.......W............W"
  Data.s "W.......W.......WWWWWWWWWWWWWW"
  Data.s "W.......W.......W............W"
  Data.s ".............................W"
  Data.s ".............................W"
  Data.s "W.......W.......W............."
  Data.s "W.......W.......W............W"
  Data.s "W.......W.......W............W"
  Data.s "WWWWWWWWW.......WWWWWWWWWWWWWW"
  Data.s "W............................W"
  Data.s "W............................W"
  Data.s "W.....DD.........DD....DD....W"
  Data.s "W.....DD.........DD....DD....W"
  Data.s "W..................I.........W"
  Data.s "W.....DD.I.......DD....DD....W"
  Data.s "W.....DD.........DD....DD....W"
  Data.s "W.....DD.........DD....DD....W"
  Data.s "W.....DD.........DD....DD....W"
  Data.s "W............................W"
  Data.s "W............................W"
  Data.s "WWWWW....WWWW....WWWW....WWWWW"

  L3Text:
  Data.s "$IT'S IN THE AIR DUCTS!" : Data.i $FFFFFF
  Data.s "BEGIN!" : Data.i $0000FF
  Data.s ""

  Level3:
  Data.i 30,30, 50, $010,$400
  Data.s ".............................."
  Data.s ".............................."
  Data.s ".............................."
  Data.s ".............................."
  Data.s ".............................."
  Data.s ".............................."
  Data.s "WWWWWWWWWWWWWWWWWWWWWWWWWWWWWW"
  Data.s "........I..I.I.I...I.........."
  Data.s ".........I.......I............"
  Data.s "WWWWWWWWWWWW....WWWWWWWWWWWWWW"
  Data.s "..........D......D............"
  Data.s ".....................D........"
  Data.s ".............................."
  Data.s ".........D...................."
  Data.s ".............................."
  Data.s "................D......D......"
  Data.s "WWWWWWWWWWWWWWWWWW....WWWWWWWW"
  Data.s "........I.......I............."
  Data.s "..................I...I......."
  Data.s "WWW.......WWWWWWWWWWWWWWWWWWWW"
  Data.s ".D.........D.................."
  Data.s ".............................."
  Data.s "WWWWWWWWWWWWWWWWWWWWWWWWWWWWWW"
  Data.s ".........I......I............."
  Data.s "..................I..........."
  Data.s "WWWWWWWWWWW....WWWWWWWWWWWWWWW"
  Data.s ".........D......D............."
  Data.s ".............................."
  Data.s ".............................."
  Data.s ".............................."


  L4Text:
  Data.s "$IT'S BREACHED THE SIERPINSKI SECTOR!" : Data.i $FFFFFF
  Data.s "BEGIN!" : Data.i $0000FF
  Data.s ""

  Level4:
  Data.i 30,30, 10, $010,$400
  Data.s ".............................."
  Data.s "..............WW.............."
  Data.s ".............W..W............."
  Data.s ".............W..W............."
  Data.s "............D....W............"
  Data.s ".................W............"
  Data.s "...........D......W..........."
  Data.s "...........W......W..........."
  Data.s "..........WWWWD.DWWW.........."
  Data.s "..........WW......WW.........."
  Data.s ".........W..W.II.D..W........."
  Data.s ".........D..W.......W........."
  Data.s ".............W..D....W........"
  Data.s "........D....W..W....W........"
  Data.s ".......W......WW......W......."
  Data.s ".......WWWWD.DWWWWWWWWD......."
  Data.s "......W.W............W........"
  Data.s "......W.W............D.D......"
  Data.s ".....D...W..............W....."
  Data.s ".........W..........D...W....."
  Data.s "....D.....W...II...W.....W...."
  Data.s "....W.....W...II...W.....W...."
  Data.s "...WWWD.DWWW......WWWWWWWWW..."
  Data.s "...WW.....WW......WW.....WD..."
  Data.s "..W..W.I.W..W....W..W.I.W....."
  Data.s "..W..D...W..W....D..W...D..D.."
  Data.s ".W......D....W.......W......W."
  Data.s ".W....D......W..D....W.D....W."
  Data.s "W......D......WW......W......W"
  Data.s "WWWWWWWWWWD..DWWWWWWWWWWWWWWWW"

  L5Text:
  Data.s "$DON'T LET IT REACH THE DIHYDROGEN MONOXIDE" : Data.i $FFFFFF
  Data.s "(AKA BLUE CIRCLES)" : Data.i $F0A000
  Data.s "OR IT WILL SPREAD TWICE AS FAST" : Data.i $FFFFFF
  Data.s "BEGIN!" : Data.i $0000FF
  Data.s ""

  Level5:
  Data.i 30,30, 60, $010,$400
  Data.s ".............................."
  Data.s ".............................."
  Data.s ".......D.WWW....D............."
  Data.s "....D....WWW........W....W...."
  Data.s "...WW........W........D......."
  Data.s "...WW........................."
  Data.s "..................W....W......"
  Data.s "..W..........................."
  Data.s ".........I........WWW...W....."
  Data.s "....WW............WWW......D.."
  Data.s "....WW........................"
  Data.s ".....................I....W..."
  Data.s "...W.........N................"
  Data.s "...D......................WW.."
  Data.s "..........................WW.."
  Data.s "........................W....."
  Data.s ".W....................D......."
  Data.s ".....D.......I................"
  Data.s "....................WW........"
  Data.s ".....WWW............WW........"
  Data.s ".....WWW.........W............"
  Data.s ".............D............W..."
  Data.s ".........W.......D............"
  Data.s ".............................."
  Data.s "..D.................W........."
  Data.s "..WW.........................."
  Data.s "..WW........W................."
  Data.s ".....................D.WWW...."
  Data.s ".......W.D.............WWW...."
  Data.s ".............................."

  L6Text:
  Data.s "$LEAD THE A-21 TO THE YELLOW CIRCLES" : Data.i $FFFFFF
  Data.s "(ERR, TETRACHLORIDE WHATEVER)" : Data.i $00F0F0
  Data.s "AND IT WILL SLOW DOWN" : Data.i $FFFFFF
  Data.s "BEGIN!" : Data.i $0000FF
  Data.s ""

  Level6:
  Data.i 30,30, 01, $010,$400
  Data.s ".............................."
  Data.s ".............................."
  Data.s ".............................."
  Data.s "........WWW.........WWW......."
  Data.s "........WWW.........WWW......."
  Data.s "........WWW.........WWW......."
  Data.s ".............................."
  Data.s ".............................."
  Data.s ".............................."
  Data.s ".............................."
  Data.s ".............................."
  Data.s "...........W.......W.........."
  Data.s "...........W.......W.........."
  Data.s "WW...WW...W.WW...WW....WW..WWW"
  Data.s ".W...W......N..I...N......W..."
  Data.s "...W..........I.I.......W...W."
  Data.s "WWW..WW...WWWWWWWWWWW.W..WW..W"
  Data.s "..........W.........W........."
  Data.s "..........W....T....W........."
  Data.s "..........W...TTT...W........."
  Data.s "..........WWWWWWWWWWW........."
  Data.s ".............................."
  Data.s ".............................."
  Data.s ".............................."
  Data.s ".............................."
  Data.s ".............................."
  Data.s "......WWWWWWWWWWWWWWWWWW......"
  Data.s "......WWWWWWWWWWWWWWWWWW......"
  Data.s "......WWWWWWWWWWWWWWWWWW......"
  Data.s ".............................."

  L7Text:
  Data.s "$ONLY A FEW A-21 LEAKS REMAIN" : Data.i $FFFFFF
  Data.s "$TAKE CARE OF THE POORLY-DESIGNED LOBBY" : Data.i $FFFFFF
  Data.s "BEGIN!" : Data.i $0000FF
  Data.s ""

  Level7:
  Data.i 30,30, 10, $010,$400
  Data.s "......W......W.....W.........."
  Data.s "......W.....W......W........WW"
  Data.s "......W....W.......W.......W.."
  Data.s "WW.....WWWWW......W.......W..."
  Data.s "..WW..W.....W....W........W..."
  Data.s "....WW......W....W........W..."
  Data.s ".....W......W....W.WWWWWWW...."
  Data.s "......W.....W.....W.......W..."
  Data.s "......W..T.W......W....T...W.."
  Data.s "......W...W........WWW.....W.."
  Data.s ".....WWWWW.....W......WWW..W.."
  Data.s "....W...........WW.......WWWWW"
  Data.s "....W......W......W..........."
  Data.s "WWWW.WW....W......WW.........."
  Data.s ".......W..W.NII.....W........."
  Data.s ".......W..W..IIN.....W.....WWW"
  Data.s "......W....W.........W....W..."
  Data.s "....WW.....W.........W...W...."
  Data.s "...W......W.....WW...W..W....W"
  Data.s "WW.......W....WW..W..W...WWWW."
  Data.s ".........W....W.T.W.......W..."
  Data.s "..WWWWWWW.....W...W.......W..."
  Data.s ".W......W.....W...W........W.."
  Data.s "W......W......W...W...W....W.."
  Data.s "......W......WW...W....W....W."
  Data.s ".....W......W..WWW.WW...W....W"
  Data.s "....W.......W........W........"
  Data.s "....W......W..........WW......"
  Data.s "....W.....W.............W....."
  Data.s "...W......W..............W...."

  Level8:
  Data.i 20,20, 0, $010,$400
  Data.s "...................."
  Data.s "..DD..DD.DD.DD..DD.."
  Data.s "..DD..DD.DD.DD..DD.."
  Data.s "..DD..DD.DD.DD..DD.."
  Data.s "..DD..DD.DD.DD..DD.."
  Data.s "...................."
  Data.s "...................."
  Data.s "...................."
  Data.s "...................."
  Data.s "...T......N.....T..."
  Data.s "...T.....II.....T..."
  Data.s "...................."
  Data.s "...................."
  Data.s "...................."
  Data.s "...................."
  Data.s "..DD..DD.DD.DD..DD.."
  Data.s "..DD..DD.DD.DD..DD.."
  Data.s "..DD..DD.DD.DD..DD.."
  Data.s "..DD..DD.DD.DD..DD.."
  Data.s "...................."

  Level9:
  Data.i 40,40, 50, $010,$400
  Data.s "TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT"
  Data.s "T......................................T"
  Data.s "T......................................T"
  Data.s "T......................................T"
  Data.s "T......................................T"
  Data.s "T......................................T"
  Data.s "T......................................T"
  Data.s "T......................................T"
  Data.s "T......................................T"
  Data.s "T......................................T"
  Data.s "T......................................T"
  Data.s "T..................I...................T"
  Data.s "T......................................T"
  Data.s "T..................I...................T"
  Data.s "T......................................T"
  Data.s "T..................I...................T"
  Data.s "T......................................T"
  Data.s "T..................I...................T"
  Data.s "T......................................T"
  Data.s "T..................I...................T"
  Data.s "T......................................T"
  Data.s "T..................I...................T"
  Data.s "T......................................T"
  Data.s "T..................N...................T"
  Data.s "T......................................T"
  Data.s "T......................................T"
  Data.s "T..................N...................T"
  Data.s "T......................................T"
  Data.s "T..................N...................T"
  Data.s "T......................................T"
  Data.s "T......WWWWWWWWWWWWWWWWWWWWWWWWW.......T"
  Data.s "T......WDWWWWWDDDDWWDWWDWWWDDDWW.......T"
  Data.s "T......WDWWWWWDWWWDWDWWDWWDWWWDW.......T"
  Data.s "T......WDWWWWWDWWWDWDDDDDWWDDDWW.......T"
  Data.s "T......WDWWWWWDWWWDWWWWDWWDWWWDW.......T"
  Data.s "T......WDDDDDWDDDDWWWWWDWWWDDDWW.......T"
  Data.s "T......WWWWWWWWWWWWWWWWWWWWWWWWW.......T"
  Data.s "T......................................T"
  Data.s "T......................................T"
  Data.s "TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT"
  
  L10Text:
  Data.s "$YOU ARE DOING GREAT!" : Data.i $FFFFFF
  Data.s "THERE IS ONLY ONE A-21 LEAK LEFT!" : Data.i $FFFFFF
  Data.s "BEGIN!" : Data.i $0000FF
  Data.s ""
  
  Level10:
  Data.i 30,30, 15, $010,$400
  Data.s ".............................."
  Data.s "..WW.WW.WW.W.WW.WWWW.W.W.WWWW."
  Data.s ".W..........................W."
  Data.s ".W..WW.WW.WW.W.WW.WW..W.WW..W."
  Data.s "....W....................W...."
  Data.s ".W..........................W."
  Data.s ".W..W.........DDD........W..T."
  Data.s "....W.........DN............W."
  Data.s ".W..W.........DDD............."
  Data.s ".W..W....................W..W."
  Data.s ".............................."
  Data.s ".W..W....................W..W."
  Data.s ".W..W....................W..W."
  Data.s "............................W."
  Data.s "....W.........II.........W...."
  Data.s ".W............II............W."
  Data.s ".W..W....................W..W."
  Data.s ".W..W.......................W."
  Data.s ".T...........DDD.........W..W."
  Data.s "....W........DND............W."
  Data.s ".W..W........D.D.........W...."
  Data.s ".............................."
  Data.s ".W.......................W..W."
  Data.s ".W..W.......................W."
  Data.s "....W....................W...."
  Data.s ".W..W.W.W.W.WW.W.W....WWWW..W."
  Data.s ".W..........................W."
  Data.s ".W..........................W."
  Data.s ".W..WWW.WW.W.W.WW.W.TW.WW.W.W."
  Data.s ".............................."
  
  EndText:
  Data.s "$ALL LEAKS CONTAINED" : Data.i $00FF00
  Data.s "SCORE-FICIENCY: %S" : Data.i $FFFF00
  Data.s "VERY WELL DONE!" : Data.i $FFFFFF
  Data.s "WE HAVE FULL CONTROL OF ANTIDOTE 21." : Data.i $FFFFFF
  Data.s "AND WITH VIRUS 21 SPREADING MORE EACH DAY," : Data.i $FFFFFF
  Data.s "OUR PROFITS IN 2012 SHOULD BE SKY-HIGH!" : Data.i $FFFFFF
  Data.s "&" : Data.i 0
  Data.s "THANKS AGAIN PAL!" : Data.i $FFFFFF
  Data.s "% " : Data.i 0
  Data.s "by ryantouk" : Data.i $404040
  Data.s "~" : Data.i 0
  Data.s ""
  
EndDataSection



; IDE Options = PureBasic 4.60 Beta 4 (Windows - x86)
; CursorPosition = 361
; Folding = --
; Executable = Chemical A-21.exe